/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#include "sqthread.h"
#include <string.h>
#include <ctype.h>

namespace sqobject {

/**
 * N[Wǂ
 */
static bool
isClosure(SQObjectType type)
{
	return type == OT_CLOSURE || type == OT_NATIVECLOSURE;
}


/**
 * 擾p
 * @param v VM
 * @param idx CfbNX
 * @return 
 */
const SQChar *getString(HSQUIRRELVM v, SQInteger idx) {
	const SQChar *x = NULL;
	sq_getstring(v, idx, &x);
	return x;
};

static SQRESULT ERROR_NOMEMBER(HSQUIRRELVM v) {
	return sq_throwerror(v, _SC("no such member"));
}

// setterO
static void pushSetterName(HSQUIRRELVM v, const SQChar *name)
{
	int len = sizeof(SQChar) * (scstrlen(name) + 4);
	SQChar *buf = (SQChar*)sq_malloc(len);
	SQChar *p = buf;
	*p++ = 's';
	*p++ = 'e';
	*p++ = 't';
	*p++ = toupper(*name++);
	while (*name) { *p++ = *name++; }
	*p++ = '\0';
	sq_pushstring(v, buf, -1);
	sq_free(buf, len);
}

// getterO
static void pushGetterName(HSQUIRRELVM v, const SQChar *name)
{
	int len = sizeof(SQChar) * (scstrlen(name) + 4);
	SQChar *buf = (SQChar*)sq_malloc(len);
	SQChar *p = buf;
	*p++ = 'g';
	*p++ = 'e';
	*p++ = 't';
	*p++ = toupper(*name++);
	while (*name) { *p++ = *name++; };
	*p++ = '\0';
	sq_pushstring(v, buf, -1);
	sq_free(buf, len);
}

// ---------------------------------------------------------
// Object
// ---------------------------------------------------------

/**
 * IuWFNg҂̓o^
 * @param thread Xbh
 */
void
Object::addWait(ObjectInfo &thread)
{
	_waitThreadList.append(thread);
}

/**
 * IuWFNg҂̉
 * @param thread Xbh
 */
void
Object::removeWait(ObjectInfo &thread)
{
	_waitThreadList.removeValue(thread, true);
}

/**
 * RXgN^
 */
Object::Object()
{
	_waitThreadList.initArray();
}

/**
 * RXgN^
 */
Object::Object(HSQUIRRELVM v, int delegateIdx)
{
	self.getStackWeak(v,1);
	_waitThreadList.initArray();
	if (sq_gettop(v) >= delegateIdx) {
		delegate.getStack(v, delegateIdx);
	}
}

/**
 * fXgN^
 */
Object::~Object()
{
	notifyAll();
	delegate.clear();
	_waitThreadList.clear();
	self.clear();
}

/**
 * ȎQƏp
 * IuWFNgK̏Ԃ
 * @param v SQUIRREL vm
 * @param idx ̃IuWFNgCfbNX
 */
void
Object::initSelf(HSQUIRRELVM v, int idx)
{
	if (sq_gettop(v) >= idx) {
		self.getStackWeak(v,idx);
	}
}

/**
 * I
 */
void
Object::destructor()
{
	callEvent(_SC("destructor"));
}

/**
 * ̃IuWFNg҂ĂPXbh̑҂
 */
void
Object::notify()
{
	SQInteger max = _waitThreadList.len();
	for (int i=0;i<max;i++) {
		Thread *th = _waitThreadList.get(i);
		if (th && th->notifyObject(self)) {
			_waitThreadList.remove(i);
			return;
		}
	}
}
	
/**
 * ̃IuWFNg҂ĂSXbh̑҂
 */
void
Object::notifyAll()
{
	SQInteger max = _waitThreadList.len();
	for (int i=0;i<max;i++) {
		Thread *th = _waitThreadList.get(i);
		if (th) {
			th->notifyObject(self);
		}
	}
	_waitThreadList.clearData();
}

/**
 * vpeBl擾
 * @param name vpeB
 * @return vpeBl
 */
SQRESULT
Object::_get(HSQUIRRELVM v)
{
	SQRESULT result = SQ_OK;
	const SQChar *name = getString(v, 2);
	if (name && *name) {
		// delegate̎Q
		if (delegate.isDelegate()) {
			delegate.push(v);
			sq_pushstring(v, name, -1);
			if (SQ_SUCCEEDED(result = sq_get(v,-2))) {
				// \bh̏ꍇ͑
				if (isClosure(sq_gettype(v,-1)) && delegate.isBindDelegate()) {
					delegate.push(v);
					if (SQ_SUCCEEDED(sq_bindenv(v, -2))) {
						sq_remove(v, -2); // ̃N[W
					}
				}
				sq_remove(v, -2);
				return 1;
			} else {
				sq_pop(v,1); // delegate
			}
		}
		
		// getter TăANZX
		sq_push(v, 1); // self
		pushGetterName(v,name); // getter
		if (SQ_SUCCEEDED(result = sq_rawget(v,-2))) {
			sq_push(v, 1); //  self;
			if (SQ_SUCCEEDED(result = sq_call(v,1,SQTrue,SQTrue))) {
				//sqprintf("Ăяo:%s\n", name);
				sq_remove(v, -2); // func
				sq_remove(v, -2); // self
				return 1;
			} else {
				sq_pop(v,2); // func, self
			}
		} else {
			sq_pop(v, 1); // self
#if 1
			// O[oϐQ
			sq_pushroottable(v);
			sq_pushstring(v, name, -1);
			if (SQ_SUCCEEDED(sq_rawget(v,-2))) {
				sq_remove(v, -2); // root
				return 1;
			} else {
				sq_pop(v,1);
			}
#endif
		}
	}
	return ERROR_NOMEMBER(v);
}

/**
 * vpeBɒlݒ
 * @param name vpeB
 * @param value vpeBl
 */
SQRESULT
Object::_set(HSQUIRRELVM v)
{
	SQRESULT result = SQ_OK;
	const SQChar *name = getString(v, 2);
	if (name && *name) {
		// delegate̎Q
		if (delegate.isDelegate()) {
			delegate.push(v);
			sq_push(v, 2); // name
			sq_push(v, 3); // value
			if (SQ_SUCCEEDED(result = sq_set(v,-3))) {
				sq_pop(v,1); // delegate
				return SQ_OK;
			} else {
				sq_pop(v,1); // delegate
			}
		}
		
		// setter TăANZX
		sq_push(v, 1); // self
		pushSetterName(v, name);
		if (SQ_SUCCEEDED(result = sq_rawget(v,-2))) {
			sq_push(v, 1); // self
			sq_push(v, 3); // value
			if (SQ_SUCCEEDED(result = sq_call(v,2,SQFalse,SQTrue))) {
				//sqprintf("Ăяo:%s\n", name);
				sq_pop(v,2); // func, self
				return SQ_OK;
			} else {
				sq_pop(v,2); // func, self
			}
		}
		
	}
	//return result;
	return ERROR_NOMEMBER(v);
}

/**
 * setvpeB̑݊mF
 * @param name vpeB
 * @return setvpeB݂ true
 */
SQRESULT
Object::hasSetProp(HSQUIRRELVM v)
{
	SQRESULT result = SQ_OK;
	SQBool ret = SQFalse;
	if (sq_gettop(v) > 1) {
		const SQChar *name = getString(v, 2);
		if (name && *name) {
			sq_push(v, 1); // object
			pushSetterName(v, name); // setter
			if (SQ_SUCCEEDED(result = sq_rawget(v,-2))) {
				sq_pop(v,1);
				ret = SQTrue;
			} else {
				sq_pushstring(v, name, -1);
				if (SQ_SUCCEEDED(result = sq_rawget(v,-2))) {
					sq_pop(v,1);
					ret = SQTrue;
				}
			}
			sq_pop(v,1); // object
		}
	}
	if (SQ_SUCCEEDED(result)) {
		sq_pushbool(v, ret);
		return 1;
	} else {
		return result;
	}
}

/**
 * Ϗ̐ݒ
 */
SQRESULT
Object::setDelegate(HSQUIRRELVM v)
{
	if (sq_gettop(v) > 1) {
		delegate.getStack(v,2);
	} else {
		delegate.clear();
	}
	return SQ_OK;
}

/**
 * Ϗ̐ݒ
 */
SQRESULT
Object::getDelegate(HSQUIRRELVM v)
{
	delegate.push(v);
	return 1;
}

bool
pushObject(HSQUIRRELVM v, Object *obj)
{
	if (obj->isInit()) {
		obj->push(v);
		return true;
	}
	return false;
}

void pushValue(HSQUIRRELVM v, const StackValue &value) { value.push(v); }

};

